#!/usr/bin/python

import sys, zlib, hashlib
from base64 import *

class RC4:
	def __init__(self, key = ""):
		if key:
			self._rc4_init(key)
           
	def _rc4_init(self, key):
		(self.x,self.y) = (0,0)
		self.state_array = [i for i in xrange(0,256)]
		for i in xrange(0,256):
			self.x = ((ord(key[i%len(key)]) & 0xff) + self.state_array[i] + self.x) & 0xff
			self.state_array[i], self.state_array[self.x] = self.state_array[self.x], self.state_array[i]
		self.x = 0

	def engine_crypt(self, input):
		self.out = []
		#self.old_state_array = self.state_array
		self.x = 0
		self.y = 0
		for i in xrange(0,len(input)):
			self.x = (self.x + 1) & 0xff
			self.y = (self.state_array[self.x] + self.y) & 0xff
			self.state_array[self.x], self.state_array[self.y] = self.state_array[self.y], self.state_array[self.x]
			self.out.append(chr((ord(input[i]) ^ self.state_array[(self.state_array[self.x] + self.state_array[self.y]) & 0xff])))
		return "".join(self.out)

def FindValue(content, start):
	try:
		f = start
		if(f > 0):
			size = ord(content[f-1])
			value = ''
			for i in range(0, size):
				value = value+content[f+i]
			return value
		else:
			return ''
	except:
		return ''
	
reloaded_key = '6ADDF834AF17EF0FCF5FDB23C53FF00A6B701250B15F0882EBD819108013F4AD8B636D011653218948F8163E9831C9B10E5140CD424D11DD16BA1EBF5D862981'.decode("hex")
debug = False

if(len(sys.argv) < 2):
	print 'Usage: python '+sys.argv[0]+' file.flp'
	print 'Execute python '+sys.argv[0]+' --about for more information'
	sys.exit(0)

if(sys.argv[1] == '--about'):
	print 'Coded by eddy14 (www.eddys-blog.6x.to)'
	print 'This application decrypts the content'
	print 'of FLP Files (google for FLP Loader)'
	print 'or Flower Project (www.flp.to).'
	print 'The decrypted information (such as host,'
	print 'username and password) are shown to you.'
	print 'Have fun! =)'
	print ''
	print 'Normal usage: '
	print 'python '+sys.argv[0]+' file.flp'
	print 'Show debug information: '
	print 'python '+sys.argv[0]+' file.flp DEBUG'
	sys.exit(0)

if(len(sys.argv) > 2):
	debug = True

if(debug == True):
	print 'Welcome! Reading file ...'
	
indata = open(sys.argv[1], "rb").read()

if(debug == True):
	print 'File Read! Decompressing ...'
	
content = indata
try:
	content = zlib.decompress(content);
	if(debug == True):
		print 'Decompressed! Decrypting eHeader...'
except:
	print 'Decompressing failed...'
	sys.exit(0)

r = RC4(reloaded_key)
size = ord(content[0])
b = content[1:1+size]
eheader = r.engine_crypt(b64decode(b))

if(eheader[0:3] == 'FLP'):
	if(debug == True):
		print 'Successful decrypted! Searching Values ...'
else:
	print 'Error while trying to decrypt the content. Maybe wrong file? Or a newer file version? I dont know ...'
	sys.exit(0)
	
comment = FindValue(content, 0x304)
uploader = FindValue(content, 0x204)
description = FindValue(content, 0x104)
	
if(debug == True):
	print 'Values read! Decrypting them...'
		
description = r.engine_crypt(b64decode(description))
uploader = r.engine_crypt(b64decode(uploader))
comment = r.engine_crypt(b64decode(comment))

if(debug == True):
	print 'Decrypted! Displaying them: '
print ''
print 'Description: '+description
print 'Uploader: '+uploader
print 'Comment: '+comment
if(debug == True):
	print 'eHeader-Key: '+eheader
print ''

Found = False
tries = 0
if(debug == True):
	print 'Displayed! Checking if eHeader is correct...'
if(eheader[0:3] == "FLP"):
	need_pass = eheader[3]
	con = eheader[7:]
	if(debug == True):
		print 'eHeader is correct. Calculating Yurry-Key ...'
	while (Found == False):
		if(need_pass == '1'):
			if(tries == 0):
				if(debug == True):
					print 'Trying "flp.to" for password ...'
				input_pass = "flp.to"
			else:
				input_pass = raw_input('Password is needed, please type in: ')
			gen_pass = hashlib.sha512("qpwripwqefsefsa"+input_pass).digest()
		else:
			gen_pass = hashlib.sha512("qpwripwqefsefsa").digest()
		
		if(debug == True):
			print 'Yurry-Key is: '+gen_pass.encode("hex")+'! Checking serial...'
			
		r = RC4(gen_pass)
		check = r.engine_crypt(b64decode(con))
		if(check == '{1F945Z9B-3ZA9-4Q13-A5DB-IDJ174DKEO91}'):
			Found = True
			if(debug == True):
				print 'Yeah, password is correct! Searching Host, Username and Password ...'
		else:
			if(tries > 0):
				print 'Hmm... this is not the correct password!'
		tries = tries + 1
else:
	print 'Oh daaaaaamn! Something went wrong while searching for "FLP" in eHeader :/ Sorry!'
	sys.exit(0)

file1 = FindValue(content, 0x405)
host = FindValue(content, 0x75C1)
username = FindValue(content, 0x7607)
password = FindValue(content, 0x763A)

if(file1 == '' or host == '' or username == '' or password == ''):
	print 'ARGH!!! Couldn\'t find Host, Username and/or Password'
	sys.exit(0)
else:
	if(debug == True):
		print 'Found Host, Username and Password. Displaying :'

print ''
r.engine_crypt(b64decode(file1))
print 'Host: '+r.engine_crypt(b64decode(host))
print 'Username: '+r.engine_crypt(b64decode(username))
print 'Password: '+r.engine_crypt(b64decode(password))
print ''

if(debug == True):
	print 'Alright then. Thanks for using :)'
